# -*- coding: utf-8 -*-

"""
   wegene.Models.Report

   This file was automatically generated by APIMATIC BETA v2.0 on 02/22/2016
"""
from wegene.APIHelper import APIHelper
from wegene.Models.GenotypesModel import GenotypesModel

class Report(object):

    """Implementation of the 'report' model.

    Report for health risk, drug response or disease carrier information

    Attributes:
        dscription (string): Description of the item
        mag (string): Research value
        odds (int): Prevelance every 100,000 people
        result (GenotypesModel): Detailed genetic information for the item
        sex (string): Sex the item applied to

    """

    def __init__(self,
                 **kwargs):
        """Constructor for the Report class

        Args:
            **kwargs: Keyword Arguments in order to initialise the
                object. Any of the attributes in this object are able to
                be set through the **kwargs of the constructor. The values
                that can be supplied and their types are as follows::

                    dscription -- string -- Sets the attribute dscription
                    mag -- string -- Sets the attribute mag
                    odds -- int -- Sets the attribute odds
                    result -- GenotypesModel -- Sets the attribute result
                    sex -- string -- Sets the attribute sex

        """
        # Set all of the parameters to their default values
        self.dscription = None
        self.mag = None
        self.odds = None
        self.result = None
        self.sex = None

        # Create a mapping from API property names to Model property names
        replace_names = {
            "dscription": "dscription",
            "mag": "mag",
            "odds": "odds",
            "result": "result",
            "sex": "sex",
        }

        # Parse all of the Key-Value arguments
        if kwargs is not None:
            for key in kwargs:
                # Only add arguments that are actually part of this object
                if key in replace_names:
                    setattr(self, replace_names[key], kwargs[key])

            # Other objects also need to be initialised properly
            if "result" in kwargs:
                self.result = GenotypesModel(**kwargs["result"])

    def resolve_names(self):
        """Creates a dictionary representation of this object.

        This method converts an object to a dictionary that represents the
        format that the model should be in when passed into an API Request.
        Because of this, the generated dictionary may have different
        property names to that of the model itself.

        Returns:
            dict: The dictionary representing the object.

        """
        # Create a mapping from Model property names to API property names
        replace_names = {
            "dscription": "dscription",
            "mag": "mag",
            "odds": "odds",
            "result": "result",
            "sex": "sex",
        }

        retval = dict()

        return APIHelper.resolve_names(self, replace_names, retval)
